package rubrica2;

import java.io.*;
import java.util.*;
import rubrica.Nominativo;
import rubrica.NominativoPrimaNome;
import rubrica.NominativoPrimaCognome;
import rubrica.NominativoFactory;

public class CreaRubrica
{
	public static void main(String[] argv) throws Exception
	{
		BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
		Rubrica rub = new Rubrica();

		while(true)
		{
			System.out.print("add/remove/search/print ? > ");
			String line = stdin.readLine();
			if(line.equals("add"))
			{
				System.out.print("nominativo? > ");
				line = stdin.readLine();
				rub.addNominativo(NominativoFactory.newNominativo(line));
			}
			else if(line.equals("remove"))
			{
				/*
				System.out.print("Nome/Cognome/Input ? > ");
				line = stdin.readLine();
				if(line == null)
				{
					continue;
				}
				Nominativo tmp = null;
				if(line.equals("Nome"))
				{
					System.out.print("Dimmi il nome > ");
					line = stdin.readLine();
					tmp = rub.cercaPerNome(line);
				}
				else if(line.equals("Cognome"))
				{
					System.out.print("Dimmi il cognome > ");
					line = stdin.readLine();
					tmp = rub.cercaPerCognome(line);
				}
				else if(line.equals("Input"))
				{
					System.out.print("Dimmi l'input > ");
					line = stdin.readLine();
					tmp = rub.cercaPerInput(line);
				}
				else
				{
					System.out.println("Chiave di ricerca <" + line + ">non riconosciuta");
				}
				rub.removeNominativo(tmp);
			*/
			}
			else if (line.equals("search"))
			{
				System.out.print("Nome/Cognome/Input ? > ");
				line = stdin.readLine();
				if(line == null)
				{
					continue;
				}
				List<Nominativo> tmp = null;
				if(line.equals("Nome"))
				{
					System.out.print("Dimmi il nome > ");
					line = stdin.readLine();
					tmp = rub.cercaPerNome(line);
				}
				else if(line.equals("Cognome"))
				{
					System.out.print("Dimmi il cognome > ");
					line = stdin.readLine();
					tmp = rub.cercaPerCognome(line);
				}
				else if(line.equals("Input"))
				{
					System.out.print("Dimmi l'input > ");
					line = stdin.readLine();
					tmp = rub.cercaPerInput(line);
				}
				else
				{
					System.out.println("Chiave di ricerca <" + line + ">non riconosciuta");
				}
				System.out.println(tmp);
			}
			else if(line.equals("print"))
			{
				System.out.println(rub.toString());
			}
			else
			{
				System.out.println("Comando <" + line + ">non riconosciuto");
			}
		}
	}
}
