package threads;

public class Notifiche
implements Runnable
{
	int temperatura;
	List<Object> lista = new LinkedList<Object>();

	public setTemp(int nuovaTemp)
	{
		synchronized(this)
		{
			temperatura = nuovaTemp;
			if(temperatura <= 4)
			{
				if(!lista.isEmpty())
				{
					Object o = lista.remove(0);
					synchronized(o)
					{
						o.notify();
					}
				}
			}
		}
	}

	public void run()
	{
		Object o = new Object();
		while(true)
		{
			synchronized(o)
			{
				synchronized(this)
				{
					if(temperatura > 4 && !lista.contains(o))
					{
						//non faccio nulla e aspetto;
						lista.add(o);
					}
					else
					{
						break;
					}
				}
				try
				{
					o.wait();
				}
				catch(InterruptedException ie)
				{
					ie.printStackTrace();
				}
			}
		}

		System.out.println("Temperatura = " + temperatura + ": GHIACCIO!!!!");
	}
}
