package threads;

public class PrimoThread
{
	public static void main(String[] argv)
	{
		(new PrimoThread()).exec(argv);
	}

	public void exec(String[] argv)
	{
		(new Thread(new PT3(1, Thread.currentThread()))).start();
		PT1 pt1 = new PT1();
		pt1.start();

		PT2 pt2 = new PT2();
		Thread t, t1, t2;
		t = new Thread(pt2, "pippo");
		//t.setDaemon(true);
		t.start();
		t1 = new Thread(new PT2(), "pippo");
		//t1.setDaemon(true);
		t1.start();
		t2 = new Thread(new PT2(), "pippo");
		//t2.setDaemon(true);
		t2.start();
		(new Thread(new PT3(7000, t1))).start();

		System.out.println("Aspetto gli altri");
		try
		{
			t.join();
			System.out.println("t finito");
			t1.join();
			System.out.println("t1 finito");
			t2.join();
			System.out.println("t2 finito");
		}
		catch(InterruptedException ie)
		{
			System.out.println("Mi sono stufato");
			ie.printStackTrace();
		}

		for(int i = 0; i < 10; i++)
		{
			try
			{
				Thread.sleep(10);
			}
			catch(InterruptedException ie)
			{
			}
			System.out.println(Thread.currentThread().getId()+ " " + i);
		}
		System.out.println("Main termina");
		pt2.end();
	}

	public class PT1
	extends Thread
	{
		public void run()
		{
			System.out.println(Thread.currentThread().getId());
		}
	}

	public class PT2
	implements Runnable
	{
		boolean go = true;

		public void run()
		{
			int i = 0;
			while(go && i < 120)
			{
				System.out.println(Thread.currentThread().getName()+ " " + Thread.currentThread().getId() + " " + i++);
				try
				{
					Thread.sleep(1000);
				}
				catch(InterruptedException ie)
				{
					System.out.println(Thread.currentThread().getName());
				}
			}
		}

		public void end()
		{
			go = false;
		}
	}

	public class PT3
	implements Runnable
	{
		Thread t;
		long millis;

		public PT3(long m, Thread theT)
		{
			this.t = theT;
			millis = m;
		}

		public void run()
		{
			try
			{
				System.out.println("Tra " + millis + " millisecondi interrompo");
				Thread.sleep(millis);
				t.interrupt();
			}
			catch(InterruptedException ie)
			{
			}
			System.out.println("Fatto");
		}
	}
}
