package giardini.orto;

import giardini.*;

public class OrtoFactory1
implements GiardiniFactory
{
	public PiantaDaBordura getPiantaDaBordura(String vincoli)
	{
		//richiede una nuova if clause per ogni nuova pianta
		if(vincoli.equals("giardini.orto.Fagiolo"))
		{
			return new Fagiolo();
		}
		else if(vincoli.equals("giardini.orto.Vite"))
		{
			return new Vite();
		}
		else
		{
			System.out.println("Non conosco la classe <" + vincoli + ">");
			return null;
		}

		return null;
	}

	public static void main(String[] argv)
	{
		int i = 0;
		OrtoFactory of = new OrtoFactory();
		for(i=0;i<argv.length;i++)
		{
			System.out.println(of.getPiantaDaBordura(argv[i]));
		}
	}
}
