package rubrica;
import java.util.*;

public class NominativoPrimaCognome
implements Nominativo
{
	private String nome, cognome;
	List<Recapito> recapiti;

	public NominativoPrimaCognome(String ilNome, String ilCognome)
	{
		nome = ilNome;
		cognome = ilCognome;
		recapiti = new LinkedList<Recapito>();
	}

	public String getNome()
	{
		return nome;
	}

	public String getCognome()
	{
		return cognome;
	}

	public String toString()
	{
		return cognome + ", " + nome;
	}

	public List<Recapito> getRecapiti()
	{
		return recapiti;
	}

	public boolean equals(Object o)
	{
		assert (o instanceof Nominativo);

		if(! (o instanceof Nominativo))
		{
			return false;
		}

		Nominativo n = (Nominativo)o;
		return (nome.equals(n.getNome()) && cognome.equals(n.getCognome()));
	}
}
